/**
 * Random function
 */
int irand(int min, int max) {
  if (max <= min) return min;
  return min + round( random(0,1)*(max - min));
}
int irands(int min, int max) { return irand( min, max )*sigrand(); }

/**
 * Random float
 */
float frand() { return random(1); }
float frand(float fmin, float fmax) { return fmin + random(1) * (fmax - fmin); }

float frands(float fmin, float fmax) { return (fmin + random(1) * (fmax - fmin)) * sigrand(); }

float flimit( float value, float fmin, float fmax ) {
  if ( value < fmin ) return fmin;
  if ( value > fmax ) return fmax;
  return value;
}

int sigrand() { return (random(1) >= 0.5) ? 1  : -1; }
/**
 * Random boolean
 */
boolean boolrand() { return random(1) >= 0.5; }

/**
 * Output a String list
 */
void printStringList(String [] strlist, boolean fnumbered) {
  if (strlist == null) { println("null"); return; }
  int n = 1;
  for (int i = 0; i < strlist.length; i++) {
    String s = "";
    if (fnumbered) s += n + ". ";
    println( s + strlist[i] );
    n++;
  }
}

float deg2rad( float deg ) { return deg * (PI/180); } 
float rad2deg( float rad ) { return rad * (180/PI); } 

/**
 * Format MM:SS
 */
String fmtMMSS( int secs ) {
  String ss = "" + ((secs % 60) +100);
  return "" + (secs / 60) + ":" + ss.substring(1); 
}

void wr(String s) { print(s); }
void wrln(String s) { println(s); }

/**
 * Return true if n is prime
 * @param n number to check
 */
boolean isPrime(int n) {
  if (n == 2 || n == 3 || n == 5 ) return true;
  if ((n % 2) == 0) return false;
  for (int i = 3; i <= n/2; i+=2) {
    if ( (n % i) == 0 ) return false;
  }
  return true;  
}

int [] reverseArr(int a[]) {
  if (a == null) return null;
  int res[] = new int[a.length];
  for (int i = 0; i < a.length; i++) {
    res[a.length-i-1] = a[i];
  }
  return res;
}

String fmtArr( int a[] ) {
  String res = "";
  for (int i = 0; i < a.length; i++) { res += (i==0)? ("" + a[i]): ("," + a[i] ); };
  return res;
}

int [] subArr(int a[], int leftdrop, int rightdrop) {
  if (a == null) return null;
  int res[] = new int[a.length - leftdrop - rightdrop];
  for (int i = leftdrop; i < a.length-rightdrop; i++) {
    res[i-leftdrop] = a[i];
  }
  return res;
}

int [] concatArr(int a[], int b[] ) {
  if (a == null) return b;
  if (b == null) return a;
  int res[] = new int[a.length + b.length];
  for (int i = 0; i < a.length; i++) res[i] = a[i];
  for (int i = 0; i < b.length; i++) res[i+a.length] = b[i];  
  return res;  
}

int []cropArr( int a[], int len ) {
  if (a == null) return null;
  int res[] = new int[len];
  for (int i = 0; i < len; i++) res[i] = a[i];
  return res;
}

int []copyArray( int a[] ) {
  int res[] = new int[ a.length ];
  for (int i = 0; i < a.length; i++) res[i] = a[i];
  return res;
}

void shuffleArray(int a[], boolean fInit) {
  if (a == null) {
    return;
  }
  if (fInit) {
    for (int i = 0; i < a.length; i++) {
     a[i] = i;
     }
  }
  for (int i = 0; i < a.length - 1; i++) {
      int tmp = a[i];
      int swap = irand(i, a.length - 1);
      a[i] = a[swap];
      a[swap] = tmp;
  }
} 

float frameToMsec() {  
  return 1000.0 * (frameCount / (1.0 * frameRate ));
}

float frameToMsec(long f) {
  return 1000.0 * ( f / (1.0 * frameRate ));
}

String secToMinSec( int secs ) {
    int mins = secs / 60;
    secs = secs % 60;
    return "" + mins + ":" + nf( secs, 2 );
}


    
